package com.ynet.life.filter;

import com.ynet.life.base.Trace;
import java.io.IOException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;

/* loaded from: com_ynet_life_filter.jar:com/ynet/life/filter/DefeatCSRFFilter.class */
public class DefeatCSRFFilter implements Filter {
    public void destroy() {
    }

    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
        HttpServletRequest httpRequest = (HttpServletRequest) request;
        String referer = httpRequest.getHeader("Referer");
        String appKey = httpRequest.getParameter("appKey");
        if (appKey != null && appKey.length() > 0 && referer != null && referer.length() > 0) {
            String domain = getDomain(referer);
            String host = getDomain(httpRequest.getRequestURL().toString());
            if (!domain.equals(host)) {
                Trace.logWarning("LifeSecurity", "EBLN:2002  用户遭遇跨站脚本攻击，攻击来源:" + referer + ",攻击链接:" + ((Object) httpRequest.getRequestURL()));
                response.setCharacterEncoding("UTF-8");
                StringBuffer sb = new StringBuffer("{");
                sb.append("\"ec\":\"EBLN2002").append("\",");
                sb.append("\"em\":\"您目前点击的链接非本站链接，可能遭受跨站脚本攻击，请退出网银并联系银行客服!").append("\"");
                sb.append("}");
                response.getOutputStream().write(sb.toString().getBytes("UTF-8"));
                return;
            }
        }
        chain.doFilter(request, response);
    }

    private String getDomain(String url) {
        String substring = url.substring(url.indexOf("//") + 2);
        String domain = substring;
        int pos = substring.indexOf("/");
        if (pos > 0) {
            domain = domain.substring(0, pos);
        }
        int pos2 = domain.indexOf(":");
        if (pos2 > 0) {
            domain = domain.substring(0, pos2);
        }
        return domain;
    }

    public void init(FilterConfig filterConfig) throws ServletException {
    }
}
